/*
 PLSI: Probabilistic Latent Semantic Indexing Tool

 $Id: matrix.h,v 1.2 2002/06/15 16:44:48 taku-ku Exp $;

 Copyright (C) 2002 Taku Kudo  All rights reserved.
 This is free software with ABSOLUTELY NO WARRANTY.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 02111-1307, USA
*/

#ifndef PLSI_MATRIX_H
#define PLSI_MATRIX_H

#include "feature_node.h"

namespace PLSI
{
  class Matrix {
  private:
    unsigned int row;
    unsigned int col;
    feature_node **matrix;
  public:
    Matrix(): row(0), col(0), matrix (0) {}
    ~Matrix() { clear (); }
    void clear ();
    bool read (const char *filename);
    unsigned int getRowNum () { return row; }
    unsigned int getColNum () { return col; }
    feature_node* getFeatureNode (unsigned int i) { return matrix[i]; }
  };
}

#endif
